import 'package:dio/dio.dart';
import 'package:flutter/material.dart';
import 'chewie.dart';
import 'video_player.dart';

enum YoutubeQuality {LOW,MEDIUM,HIGH,HD,FHD}

class YoutubePlayer extends StatefulWidget {
  final String youtubeId;
  final YoutubeQuality quality;

  YoutubePlayer({@required this.youtubeId,this.quality});

  @override
  State<StatefulWidget> createState() {
    return _YoutubePlayerState();
  }
}

class _YoutubePlayerState extends State<YoutubePlayer> {
  VideoPlayerController _controller;
  Map url;
  bool showVideo = false;
  List urls = <String>[];
  String quality = "";

  @override
  void initState() {
    super.initState();
    loadUrl();
  }

  loadUrl() async {
    url = await getYoutubeUrls(widget.youtubeId);
    _controller = VideoPlayerController.network(
        url['720p'] + "sarbagya" + url['aac']
    );
    setState(() {
      showVideo = true;
    });
  }

  @override
  Widget build(BuildContext context) {
    return Column(
      children: <Widget>[
        Expanded(
          child: Center(
            child: showVideo
                ? Chewie(
              _controller,
              aspectRatio: 16 / 9,
              autoPlay: true,
              looping: true,
              materialProgressColors: ChewieProgressColors(
                bufferedColor: Colors.red,
                playedColor: Colors.red,
                handleColor: Colors.red,
                backgroundColor: Colors.black,
              ),
            )
                : CircularProgressIndicator(),
          ),
        ),
        Text("sarbagya"),
      ],
    );
  }

  void qualityMapping(){

  }

  Future<Map> getYoutubeUrls(String youtubeId) async {
    var rawURLs = <String>[];
    var tempUrl;
    var tempDecodedUrl;
    var tempQuality;
    var currentQuality = "";
    Map youtubeUrls = {};
    Dio dio = Dio();
    var result = await dio.get('https://www.youtube.com/watch?v=$youtubeId');
    rawURLs = result.data.toString().split(r'\"url\":\"');
    rawURLs.forEach((url) {
      if (url.contains("mimeType")) {
        tempUrl = url.split(r'\",\"mimeType\":\"').first;
        if (tempUrl.contains('mime=video%2Fmp4')) {
          tempDecodedUrl = tempUrl.replaceAll(r'\u0026', '&').replaceAll(r'\', '');

          if ((tempQuality = url.split(r'\",\"mimeType\":\"')[1])
              .contains(r'\"qualityLabel\":\"')) {
            tempQuality =
            tempQuality.toString().split(r'\"qualityLabel\":\"')[1];
            tempQuality =
                tempQuality.toString().split(r'\",\"projectionType\"').first;
          }
          if (currentQuality != tempQuality) {
            youtubeUrls[tempQuality] = tempDecodedUrl;
            currentQuality = tempQuality;
          }
        }
        if (tempUrl.contains('mime=audio%2Fmp4')) {
          youtubeUrls['aac'] = tempUrl.replaceAll(r'\u0026', '&').replaceAll(r'\', '');
        }
      }
    });
    return youtubeUrls;
  }
}
